package model.lib;

import java.io.File;
import java.io.FileNotFoundException;

/**
 *
 * @author docente
 */
public class CrudFile<K extends Comparable,V extends RAK<K>> implements Crud<K,V> {
    SequenzaFile<V> s;

    public CrudFile(V maker,File fseq) throws FileNotFoundException {
        s = new SequenzaFile<V>(maker,fseq);
    }

  @Override
  public void create(V value) throws Exception {
    try {
      trovaIndice(value.getKey());
    }
    catch (Exception e) {
      s.appendi(value);
      return;
    }
    throw new Exception("Duplicate key: "+value.getKey());
  }

  @Override
  public void delete(K key) throws Exception {
    s.elimina(trovaIndice(key));
  }

  @Override
  public V read(K key) throws Exception {
    return s.getElemento(trovaIndice(key));
  }

  @Override
  public void update(V value) throws Exception {
    int i= trovaIndice(value.getKey());
    s.setElemento(value, i);
  }
  
  private int trovaIndice(K key) throws Exception{
    int lung = s.getLunghezza();
    for (int i = 0; i < lung; i++) {
      if (s.getElemento(i).getKey().compareTo(key)==0){
        return i;
      }      
    }
    throw new Exception("Not found");
  }
    
}
